package userRules;

import java.awt.*;
import java.util.Random;
import cellularAutomata.rules.templates.IntegerRuleTemplate;

import javax.swing.*;

public class MyRule extends IntegerRuleTemplate
{
    // a display name for this class
    private static final String RULE_NAME = "My Cool Rule";

    // a tooltip description for this rule
    private static final String TOOLTIP =
            "<html><body><b>"+RULE_NAME +".</b> This rule does wicked cool things."
                    + "<body></html>";
    private static volatile int ran=0;
    static volatile JSpinner aloneDeathSpin, returnSpin, tooMuchDeathSpin, birthWithNewSpin, birthWithStableSpin, birthWithOldSpin,
            birthThresholdSpin, deathAloneThresholdSpin, deathTooMuchThresholdSpin,birthWithNewSpin2, birthWithStableSpin2, birthWithOldSpin2;
    private final int neverUsed=0, stableUser=1, newUser=2, oldUser=3, usedButDie=4;
    private static volatile int sumNewUser=0, sumStableUser=0, sumOldUser=0,sumNewUser2=0, sumStableUser2=0, sumOldUser2=0;
    private static volatile int birthThreshold=0, deathAloneThreshold=0, deathTooMuchThreshold=0;
    private static volatile double probOfReturn=0, probOfDieAlone=0, probOfDieIfTooMuch=0, probOfBirthWithNew=0, probOfBirthWithStable=0, probOfBirthWithOld=0, probOfBirthWithNew2=0, probOfBirthWithStable2=0, probOfBirthWithOld2=0;
   // private static volatile int birthGen;
    Random random = new Random();

    /**
     * Create my cool rule.
     *
     * @param minimalOrLazyInitialization
     *            May be safely ignored.
     */
    public MyRule(boolean minimalOrLazyInitialization)
    {
        super(minimalOrLazyInitialization);
    }

    /**
     * This is where the real rule happens.  Everything else is just
     * window dressing!
     *
     * @param cell
     *            The value of the cell being updated.
     * @param neighbors
     *            The value of the neighbors.
     * @param numStates
     *            The total number of states allowed in this rule.
     * @param generation
     *            The current generation of the CA.
     *
     * @return A new state for the cell.
     */
    protected int integerRule(int cell, int[] neighbors, int numStates,
                              int generation)
    {
        sumNewUser=sumStableUser=sumOldUser=sumNewUser2=sumStableUser2=sumOldUser2=0;
        probOfReturn=(Double)((SpinnerNumberModel)returnSpin.getModel()).getNumber().doubleValue();
        probOfDieAlone=(Double)((SpinnerNumberModel)aloneDeathSpin.getModel()).getNumber().doubleValue();
        probOfDieIfTooMuch=(Double)((SpinnerNumberModel)tooMuchDeathSpin.getModel()).getNumber().doubleValue();
        probOfBirthWithNew=(Double)((SpinnerNumberModel)birthWithNewSpin.getModel()).getNumber().doubleValue();
        probOfBirthWithNew2=(Double)((SpinnerNumberModel)birthWithNewSpin2.getModel()).getNumber().doubleValue();
        probOfBirthWithStable=(Double)((SpinnerNumberModel)birthWithStableSpin.getModel()).getNumber().doubleValue();
        probOfBirthWithStable2=(Double)((SpinnerNumberModel)birthWithStableSpin2.getModel()).getNumber().doubleValue();
        probOfBirthWithOld=(Double)((SpinnerNumberModel)birthWithOldSpin.getModel()).getNumber().doubleValue();
        probOfBirthWithOld2=(Double)((SpinnerNumberModel)birthWithOldSpin2.getModel()).getNumber().doubleValue();
        birthThreshold=(Integer)((SpinnerNumberModel)birthThresholdSpin.getModel()).getNumber().intValue();
        deathAloneThreshold=(Integer)((SpinnerNumberModel)deathAloneThresholdSpin.getModel()).getNumber().intValue();
        deathTooMuchThreshold=(Integer)((SpinnerNumberModel)deathTooMuchThresholdSpin.getModel()).getNumber().intValue();


        for (int i = 0; i < neighbors.length; i++) {
            if (i<8) {
                if (neighbors[i] == newUser) sumNewUser++;
                if (neighbors[i] == stableUser) sumStableUser++;
                if (neighbors[i] == oldUser) sumOldUser++;
            }
            else {
                if (neighbors[i] == newUser) sumNewUser2++;
                if (neighbors[i] == stableUser) sumStableUser2++;
                if (neighbors[i] == oldUser) sumOldUser2++;
            }
        }
        int sumAllLiveUsers = sumNewUser+sumNewUser2+sumStableUser+sumStableUser2+sumOldUser+sumOldUser2;
        if (cell==neverUsed) {
            ran=random.nextInt(100000)+1;
            if (sumAllLiveUsers>=birthThreshold) {
                if (ran <= ((sumNewUser*probOfBirthWithNew+sumStableUser * probOfBirthWithStable + sumOldUser * probOfBirthWithOld)
                        +(sumNewUser2 * probOfBirthWithNew2 + sumStableUser2 * probOfBirthWithStable2 + sumOldUser2 * probOfBirthWithOld2)) * 1000)
                    return newUser;
            }
        }
        if (cell==stableUser) {
            if (generation%1000==0&&generation!=0)
                return usedButDie;
            }

        if (cell==newUser) {
            return oldUser;
        }
        if (cell==oldUser) {
            if (sumAllLiveUsers<=deathAloneThreshold) {
                    ran = random.nextInt(100000) + 1;
                    if (ran <= (probOfDieAlone * 1000)) return usedButDie;
            }
            if (sumAllLiveUsers>=deathTooMuchThreshold) {
                    ran = random.nextInt(100000) + 1;
                    if (ran <= (probOfDieIfTooMuch * 1000)) return usedButDie;
            }
        }
        if (cell==usedButDie) {
            ran=random.nextInt(100000)+1;
            if (ran<=((sumAllLiveUsers+probOfReturn)*1000)) return oldUser;
        }
        return cell;
    }

    /**
     * A brief one or two-word string describing the rule, appropriate for
     * display in a drop-down list.
     *
     * @return A string no longer than 15 characters.
     */
    public String getDisplayName()
    {
        return RULE_NAME;
    }

    /**
     * A brief description (written in HTML) that describes this rule. The
     * description will be displayed as a tooltip. Using html permits line
     * breaks, font colors, etcetera, as described in HTML resources. Regular
     * line breaks will not work.
     *
     * @return An HTML string describing this rule.
     */
    public String getToolTipDescription()
    {
        return TOOLTIP;
    }

    public JPanel getAdditionalPropertiesPanel(){
        JPanel jPanel = new JPanel();
        jPanel.setLayout(new BoxLayout(jPanel,BoxLayout.PAGE_AXIS));
        jPanel.add(new JLabel("Минимальное кол-во соседей"));
        jPanel.add(new JLabel("для рождения клетки"));
        birthThresholdSpin = new JSpinner(new SpinnerNumberModel(1,0,24,1));
        jPanel.add(birthThresholdSpin);
        JLabel birthWithNewLbl = new JLabel("Влияние новых пользователей на клетку");
        jPanel.add(birthWithNewLbl);
        jPanel.add(new JLabel("(Вероятность рассчитывается как кол-во"));
        jPanel.add(new JLabel("соседей этого состояния * влияние)"));
        jPanel.add(new JLabel("1-ый контур"));
        birthWithNewSpin = new JSpinner(new SpinnerNumberModel(1,0,100,0.001));
        jPanel.add(birthWithNewSpin);
        jPanel.add(new JLabel("2-ой контур"));
        birthWithNewSpin2 = new JSpinner(new SpinnerNumberModel(1,0,100,0.001));
        jPanel.add(birthWithNewSpin2);
        JLabel birthWithOldLbl = new JLabel("Влияние обычных пользователей на клетку");
        jPanel.add(birthWithOldLbl);
        jPanel.add(new JLabel("(Вероятность рассчитывается как кол-во"));
        jPanel.add(new JLabel("соседей этого состояния * влияние)"));
        jPanel.add(new JLabel("1-ый контур"));
        birthWithOldSpin = new JSpinner(new SpinnerNumberModel(1,0,100,0.001));
        jPanel.add(birthWithOldSpin);
        jPanel.add(new JLabel("2-ой контур"));
        birthWithOldSpin2 = new JSpinner(new SpinnerNumberModel(1,0,100,0.001));
        jPanel.add(birthWithOldSpin2);
        JLabel birthWithStableLbl = new JLabel("Влияние пользователей-фанатов на клетку");
        jPanel.add(birthWithStableLbl);
        jPanel.add(new JLabel("(Вероятность рассчитывается как кол-во"));
        jPanel.add(new JLabel("соседей этого состояния * влияние)"));
        jPanel.add(new JLabel("1-ый контур"));
        birthWithStableSpin = new JSpinner(new SpinnerNumberModel(1,0,100,0.001));
        jPanel.add(birthWithStableSpin);
        jPanel.add(new JLabel("2-ой контур"));
        birthWithStableSpin2 = new JSpinner(new SpinnerNumberModel(1,0,100,0.001));
        jPanel.add(birthWithStableSpin2);
        jPanel.add(new JLabel("Максимальное кол-во соседей"));
        jPanel.add(new JLabel("для отказа от одиночества"));
        deathAloneThresholdSpin = new JSpinner(new SpinnerNumberModel(1,0,24,1));
        jPanel.add(deathAloneThresholdSpin);
        JLabel aloneDeathLbl = new JLabel("Вероятность отказа от одиночества");
        jPanel.add(aloneDeathLbl);
        jPanel.add(new JLabel("(0.001-100)"));
        aloneDeathSpin = new JSpinner(new SpinnerNumberModel(1,0,100,0.001));
        jPanel.add(aloneDeathSpin);
        jPanel.add(new JLabel("Минимальное кол-во соседей"));
        jPanel.add(new JLabel("для отказа от перенаселения"));
        deathTooMuchThresholdSpin = new JSpinner(new SpinnerNumberModel(23,0,24,1));
        jPanel.add(deathTooMuchThresholdSpin);
        JLabel tooMuchDeathLbl = new JLabel("Вероятность отказа от перенеаселения");
        jPanel.add(tooMuchDeathLbl);
        jPanel.add(new JLabel("(0.001-100)"));
        tooMuchDeathSpin = new JSpinner(new SpinnerNumberModel(1,0,100,0.001));
        jPanel.add(tooMuchDeathSpin);
        JLabel returnLbl = new JLabel("Вероятность возвращения после отказа");
        jPanel.add(returnLbl);
        jPanel.add(new JLabel("кол-во живых соседей"));
        jPanel.add(new JLabel("* на вероятность"));
        returnSpin = new JSpinner(new SpinnerNumberModel(1,0,100,0.001));
        jPanel.add(returnSpin);
        return jPanel;
    }
}